unit unGrupoPesquisa;

interface

uses
  Classes, Controls, StdCtrls;

type

TGrupoPesquisa = class(TGroupBox)
  private
    FEditPesquisa: TEdit;
    FButtonPesquisa: TButton;
    FLabelPesquisa: TLabel;
  protected
    procedure SetPosicaoSubComponentes;
    procedure SetParent(AParent: TWinControl); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    procedure SetBounds(ALeft: Integer; ATop: Integer; AWidth: Integer; AHeight: Integer); override;
    constructor Create(AOwner: Tcomponent);override;
    destructor Destroy; override;
  published
    property PesquisaEdit: TEdit read FEditPesquisa;
    property PesquisaButton: TButton read FButtonPesquisa;
    property PesquisaLabel: TLabel read FLabelPesquisa;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Componente Composto', [TGrupoPesquisa]);
end;

constructor TGrupoPesquisa.Create(AOwner: Tcomponent);
begin
  inherited;

  Caption := 'Realizar Pesquisar ';
  Height := 50;
  Width := 200;

  if FEditPesquisa = nil then
  begin
    FEditPesquisa := TEdit.Create(Self);
    FEditPesquisa.Name := 'PesquisaEdit';
    FEditPesquisa.Text := '';
    FEditPesquisa.Visible := True;
    FEditPesquisa.SetSubComponent(True);
    FEditPesquisa.FreeNotification(Self);
  end;

  if FButtonPesquisa = nil then
  begin
    FButtonPesquisa := TButton.Create(Self);
    FButtonPesquisa.Name := 'PesquisaButton';
    FButtonPesquisa.Caption := 'Pesquisar';
    FButtonPesquisa.Visible := True;
    FButtonPesquisa.SetSubComponent(True);
    FButtonPesquisa.FreeNotification(Self);
  end;

  if FLabelPesquisa = nil then
  begin
    FLabelPesquisa := TLabel.Create(Self);
    FLabelPesquisa.Name := 'PesquisaLabel';
    FLabelPesquisa.Caption := 'Label fora do TGrupoPesquisa';
    FLabelPesquisa.Visible := True;
    FLabelPesquisa.AutoSize := False;
    FLabelPesquisa.SetSubComponent(True);
    FLabelPesquisa.FreeNotification(Self);
  end;
end;

destructor TGrupoPesquisa.Destroy;
begin
  inherited Destroy;
end;

procedure TGrupoPesquisa.SetParent(AParent: TWinControl);
begin
  inherited SetParent(AParent);

  if FEditPesquisa <> nil then
    FEditPesquisa.Parent := Self;

  if FButtonPesquisa <> nil then
    FButtonPesquisa.Parent := Self;

  if FLabelPesquisa <> nil then
    FLabelPesquisa.Parent := AParent;
end;
         
procedure TGrupoPesquisa.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);

  if (AComponent = FEditPesquisa) and (Operation = opRemove) then
    FEditPesquisa := nil
  else if (AComponent = FButtonPesquisa) and (Operation = opRemove) then
    FButtonPesquisa := nil
  else if (AComponent = FLabelPesquisa) and (Operation = opRemove) then
    FLabelPesquisa := nil;
end;

procedure TGrupoPesquisa.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);

  SetPosicaoSubComponentes;
end;

procedure TGrupoPesquisa.SetPosicaoSubComponentes;
begin
  if FEditPesquisa <> nil then
    FEditPesquisa.SetBounds(5, 20, 120, 20);

  if FButtonPesquisa <> nil then
    FButtonPesquisa.SetBounds(FEditPesquisa.Width + 10, 20, 60, 20);

  if FLabelPesquisa <> nil then
    FLabelPesquisa.SetBounds(Self.Left, Self.Top - 20, Self.Width, 15);
end;

end.
